searchNodes=[{"ref":"AVR.html","title":"AVR","type":"module","doc":"AVR is a library to upload a firmware into AVR microcontrollers"},{"ref":"AVR.html#update/4","title":"AVR.update/4","type":"function","doc":"See AVR.Flasher.update/4."},{"ref":"AVR.html#upload/4","title":"AVR.upload/4","type":"function","doc":"See AVR.Flasher.upload/4."},{"ref":"AVR.html#verify/4","title":"AVR.verify/4","type":"function","doc":"See AVR.Flasher.verify/4."},{"ref":"AVR.html#t:board_type/0","title":"AVR.board_type/0","type":"type","doc":""},{"ref":"AVR.html#t:upload_opt/0","title":"AVR.upload_opt/0","type":"type","doc":""},{"ref":"AVR.html#t:upload_opts/0","title":"AVR.upload_opts/0","type":"type","doc":""},{"ref":"AVR.Flasher.html","title":"AVR.Flasher","type":"module","doc":"Provides the basic functionality for upload/download/verify the device firmware"},{"ref":"AVR.Flasher.html#update/4","title":"AVR.Flasher.update/4","type":"function","doc":"Verifies if the firmware is already loaded on the device. If the device firmware is different the hex will be uploaded."},{"ref":"AVR.Flasher.html#upload/4","title":"AVR.Flasher.upload/4","type":"function","doc":"Uploads the firmware to the device"},{"ref":"AVR.Flasher.html#verify/4","title":"AVR.Flasher.verify/4","type":"function","doc":"Reads and verifies the firmware to the device"},{"ref":"readme.html","title":"AVR","type":"extras","doc":"AVR AVR Firmware Uploader (Only Arduino targets are supported)."},{"ref":"readme.html#why","title":"AVR - Why?","type":"extras","doc":"Usually in my projects I need hard realtime (e.g. Send/Receive IR signals) which is a complicated task to achieve with Nerves because you have the erlang scheduler plus the OS multitasking. So for those times where realtime is needed the simplest solution is to have hardware that supports it like an Arduino. But wait... what if I want to also update my little Arduino companion firmware as easy as I update my app firmware? The Goal To accomplish this goal I need: The firmware loader: This is done (At least for the Arduino models I use). Firmware version check mechanism: A way to check the current companion firmware version installed (Maybe storing the version on the EEPROM or reading and comparing the firmware in the device). Automated updater: An app to be included in the project to update (Maybe at boot time) the companion/s firmware when is necessary. Compiler task (Optional): To include the Arduino source in the Nerves project and compile the hex file on build."},{"ref":"readme.html#usage","title":"AVR - Usage","type":"extras","doc":"AVR.upload(&quot;foo/bar/binary.compiled.hex&quot;, &quot;ttyACM0&quot;, :uno) IMPORTANT! The hex file has to be compiled to match the target hardware (MCU and Clock speed)"},{"ref":"readme.html#supported-boards","title":"AVR - Supported boards:","type":"extras","doc":":uno: Arduino Uno :pro8MHzatmega328p: Arduino Pro or Pro Mini ATmega328 (3.3V, 8 MHz) :pro16MHzatmega328p: Arduino Pro or Pro Mini ATmega328 (5V, 16 MHz) :atmega328: Generic ATmega328 :atmega328p: Generic ATmega328P"},{"ref":"readme.html#auto-reset","title":"AVR - Auto-reset","type":"extras","doc":"Arduino boards needs to be reseted to enable the programing mode. The reset is performed automatically using the DTR line when the board is connected by USB. To use the RPi hardware serial port you need to configure a GPIO pin to work as a reset line using the gpio_reset option: AVR.upload(&quot;foo/bar/binary.compiled.hex&quot;, &quot;ttyACM0&quot;, :uno, gpio_reset: 4) On this case, the GPIO04 will be connected to the reset pin. NOTE: The reset works putting the RESET pint to LOW for a few milliseconds. For this reason you have to use the GPIOs with pull-up resistors (GPIO0-GPIO8)."},{"ref":"readme.html#installation","title":"AVR - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding avr to your list of dependencies in mix.exs: def deps do [ {:avr, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/avr."}]